import React from "react";
export const useEnhancedEffect: typeof React.useLayoutEffect;
export function useId(deterministicId?: string): string;
type MediaQueryCallback = ((query: string) => MediaQueryList) | null;
export function useMediaQuery(queryInput: string, options?: {
    defaultMatches?: boolean;
    matchMedia?: MediaQueryCallback;
    serverMatchMedia?: MediaQueryCallback;
}): boolean;
export function useToggle<V>(initialValue: V, values: [V, V]): readonly [V, (value?: React.SetStateAction<V> | undefined) => void];
export function useBoolean(initialValue?: boolean): readonly [boolean, (value?: import("react").SetStateAction<boolean> | undefined) => void];
export function useWindowEvent<E extends keyof WindowEventMap>(event: E, listener: (this: Window, event: WindowEventMap[E] | EventListenerOrEventListenerObject) => any, options?: AddEventListenerOptions | boolean): void;
export function useViewportSize(): {
    width: number;
    height: number;
};

//# sourceMappingURL=backyard-ui-hooks.d.ts.map
