import $6Nqih$react, {useEffect as $6Nqih$useEffect} from "react";
import {useTheme as $6Nqih$useTheme, getThemeProps as $6Nqih$getThemeProps} from "@backyard-ui/styles";



const $be7eb03afe4caf66$export$4e09c449d6c407f7 = typeof window !== 'undefined';



const $48f00a95cf5ab250$var$useEnhancedEffect = $be7eb03afe4caf66$export$4e09c449d6c407f7 ? $6Nqih$react.useLayoutEffect : $6Nqih$react.useEffect;
var $48f00a95cf5ab250$export$2e2bcd8739ae039 = $48f00a95cf5ab250$var$useEnhancedEffect;



const $309d184348240484$var$useReactId = $6Nqih$react['useId'.toString()] || (()=>undefined
);
let $309d184348240484$var$count = 0;
function $309d184348240484$var$useId(deterministicId) {
    const [id, setId] = $6Nqih$react.useState($309d184348240484$var$useReactId());
    $48f00a95cf5ab250$export$2e2bcd8739ae039(()=>{
        if (!deterministicId) setId((reactId)=>reactId ?? String($309d184348240484$var$count++)
        );
    }, [
        deterministicId
    ]);
    return deterministicId || (id ? `backyard-ui-${id}` : '');
}
var $309d184348240484$export$2e2bcd8739ae039 = $309d184348240484$var$useId;







function $2afd77a4cb7edf01$var$useMediaStore(query, defaultMatches, matchMedia, serverMatchMedia) {
    const defaultSnapshot = $6Nqih$react.useCallback(()=>defaultMatches
    , [
        defaultMatches
    ]);
    const getServerSnapshot = $6Nqih$react.useMemo(()=>{
        if (serverMatchMedia !== null) {
            const { matches: matches  } = serverMatchMedia(query);
            return ()=>matches
            ;
        }
        return defaultSnapshot;
    }, [
        defaultSnapshot,
        query,
        serverMatchMedia
    ]);
    const [getSnapshot, subscribe] = $6Nqih$react.useMemo(()=>{
        if (matchMedia === null) return [
            defaultSnapshot,
            ()=>()=>{}
        ];
        const queryList = matchMedia(query);
        /**
     * NOTE:
     * Support for Safari < 14
     * https://stackoverflow.com/questions/56466261/matchmedia-addlistener-marked-as-deprecated-addeventlistener-equivalent
     * */ return [
            ()=>queryList.matches
            ,
            (notify)=>{
                try {
                    queryList.addEventListener('change', notify);
                    return ()=>queryList.removeEventListener('change', notify)
                    ;
                } catch (e) {
                    queryList.addListener(notify);
                    return ()=>queryList.removeListener(notify)
                    ;
                }
            }
        ];
    }, [
        defaultSnapshot,
        matchMedia,
        query
    ]);
    const match = $6Nqih$react.useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
    return match;
}
function $2afd77a4cb7edf01$var$useMediaQuery(queryInput, options = {}) {
    const hasSupport = $be7eb03afe4caf66$export$4e09c449d6c407f7 && 'matchMedia' in window;
    const { theme: theme  } = $6Nqih$useTheme();
    const { defaultMatches: defaultMatches = false , matchMedia: matchMedia = hasSupport ? window.matchMedia : null , serverMatchMedia: serverMatchMedia = null  } = $6Nqih$getThemeProps({
        name: 'UseMediaQuery',
        props: options,
        theme: theme
    });
    const query = queryInput.replace(/^@media( ?)/m, '');
    const match = $2afd77a4cb7edf01$var$useMediaStore(query, defaultMatches, matchMedia, serverMatchMedia);
    return match;
}
var $2afd77a4cb7edf01$export$2e2bcd8739ae039 = $2afd77a4cb7edf01$var$useMediaQuery;




function $b0f8a959d5cfa261$var$useToggle(initialValue, values) {
    const [state, setState] = $6Nqih$react.useState(initialValue);
    const toggle = (value)=>{
        if (typeof value !== 'undefined') setState(value);
        else setState((current)=>{
            if (current === values[0]) return values[1];
            return values[0];
        });
    };
    return [
        state,
        toggle
    ];
}
var $b0f8a959d5cfa261$export$2e2bcd8739ae039 = $b0f8a959d5cfa261$var$useToggle;




function $462a77a51e90cb2b$var$useBoolean(initialValue = false) {
    return $b0f8a959d5cfa261$export$2e2bcd8739ae039(initialValue, [
        true,
        false
    ]);
}
var $462a77a51e90cb2b$export$2e2bcd8739ae039 = $462a77a51e90cb2b$var$useBoolean;






function $b2456537edd4b380$var$useWindowEvent(event, listener, options) {
    $6Nqih$useEffect(()=>{
        window.addEventListener(event, listener, options);
        return ()=>window.removeEventListener(event, listener, options)
        ;
    });
}
var $b2456537edd4b380$export$2e2bcd8739ae039 = $b2456537edd4b380$var$useWindowEvent;



function $493550af1ebb684d$var$useViewportSize() {
    const [windowSize, setWindowSize] = $6Nqih$react.useState({
        width: $be7eb03afe4caf66$export$4e09c449d6c407f7 ? window.innerWidth : 0,
        height: $be7eb03afe4caf66$export$4e09c449d6c407f7 ? window.innerHeight : 0
    });
    const getSize = $6Nqih$react.useCallback(()=>{
        setWindowSize({
            width: window.innerWidth || 0,
            height: window.innerHeight || 0
        });
    }, []);
    $b2456537edd4b380$export$2e2bcd8739ae039('resize', getSize, {
        passive: true
    });
    $b2456537edd4b380$export$2e2bcd8739ae039('orientationchange', getSize, {
        passive: true
    });
    return windowSize;
}
var $493550af1ebb684d$export$2e2bcd8739ae039 = $493550af1ebb684d$var$useViewportSize;






export {$309d184348240484$export$2e2bcd8739ae039 as useId, $48f00a95cf5ab250$export$2e2bcd8739ae039 as useEnhancedEffect, $2afd77a4cb7edf01$export$2e2bcd8739ae039 as useMediaQuery, $b0f8a959d5cfa261$export$2e2bcd8739ae039 as useToggle, $462a77a51e90cb2b$export$2e2bcd8739ae039 as useBoolean, $493550af1ebb684d$export$2e2bcd8739ae039 as useViewportSize, $b2456537edd4b380$export$2e2bcd8739ae039 as useWindowEvent};
//# sourceMappingURL=backyard-ui-hooks.esm.js.map
